package com.osoboo.jira.metadata;

import net.java.ao.Entity;
import net.java.ao.Preload;

/**
 * the metadata object. unique key = key + enrichedObjectKey.
 * 
 * @author aspall
 * 
 */
@Preload
public interface Metadata extends Entity {

	/**
	 * @return e.g. com.atlassian.jira.project.Project:OS for the project os
	 */
	String getEnrichedObjectKey();

	/**
	 * @param enrichedObjectKey
	 *            the to enrich object key
	 */
	void setEnrichedObjectKey(String enrichedObjectKey);

	/**
	 * @return the metadata key
	 */
	String getKey();

	/**
	 * @param key
	 *            the metadata key
	 */
	void setKey(String key);

	/**
	 * @return the value
	 */
	String getValue();

	/**
	 * @param value
	 */
	void setValue(String value);

}
