package com.osoboo.jira.metadata.ui.field;

import java.util.Map;

import org.apache.velocity.tools.generic.MathTool;

import com.atlassian.jira.ComponentManager;
import com.atlassian.jira.issue.Issue;
import com.atlassian.jira.issue.customfields.manager.GenericConfigManager;
import com.atlassian.jira.issue.customfields.persistence.CustomFieldValuePersister;
import com.atlassian.jira.issue.fields.CustomField;
import com.atlassian.jira.security.JiraAuthenticationContext;
import com.atlassian.jira.util.JiraVelocityUtils;
import com.atlassian.plugin.web.WebFragmentHelper;
import com.osoboo.jira.metadata.MetadataService;

@SuppressWarnings("unchecked")
public class MetadataCalcFieldType extends MetadataCalculatedCFType {

	private final WebFragmentHelper webFragmentHelper;
	private MetadataService metadataService;

	protected MetadataCalcFieldType(
			CustomFieldValuePersister customFieldValuePersister,
			GenericConfigManager genericConfigManager,
			JiraAuthenticationContext authenticationContext,
			WebFragmentHelper webFragmentHelper, MetadataService metadataService) {
		super(customFieldValuePersister, genericConfigManager);
		this.webFragmentHelper = webFragmentHelper;
		this.metadataService = metadataService;
	}


	@Override
	public Object getValueFromIssue(CustomField arg0, Issue arg1) {
		try {
			final Map<String, Object> startingParams = JiraVelocityUtils
					.getDefaultVelocityParams(ComponentManager.getInstance()
							.getJiraAuthenticationContext());
			startingParams.put("issue", arg1);
			startingParams.put("customField", arg0);
			startingParams.put("metadataService", metadataService);
			startingParams.put("math", new MathTool());
			return webFragmentHelper.renderVelocityFragment(
					getDefaultValue(arg0.getRelevantConfig(arg1)).toString(),
					startingParams);
		} catch (Exception e) {
			return "";
		}
	}





}
