package com.osoboo.jira.metadata.ui.field;

import com.atlassian.jira.issue.Issue;
import com.atlassian.jira.issue.customfields.manager.GenericConfigManager;
import com.atlassian.jira.issue.customfields.persistence.CustomFieldValuePersister;
import com.atlassian.jira.issue.fields.CustomField;
import com.osoboo.jira.metadata.MetadataService;

@SuppressWarnings("unchecked")
public class ProjectMetadataViewFieldType extends MetadataCalculatedCFType {

	private final MetadataService metadataService;

	protected ProjectMetadataViewFieldType(
			CustomFieldValuePersister customFieldValuePersister,
			GenericConfigManager genericConfigManager,
			MetadataService metadataService) {
		super(customFieldValuePersister, genericConfigManager);
		this.metadataService = metadataService;
	}

	@Override
	public Object getValueFromIssue(CustomField arg0, Issue arg1) {
		return metadataService.getMetadataValue(arg1.getProjectObject(),
				(String) getDefaultValue(arg0.getRelevantConfig(arg1)));
	}





}
