package com.osoboo.jira.metadata.ui.internal;

import webwork.action.ServletActionContext;

import com.atlassian.jira.web.action.JiraWebActionSupport;
import com.osoboo.jira.metadata.MetadataService;

public class ProjectMetadataDelete extends JiraWebActionSupport {

	/** */
	private static final long serialVersionUID = 7861762358377860485L;

	private int metadataKey;

	private String projectKey;

	private final MetadataService metadataService;

	public ProjectMetadataDelete(MetadataService metadataService) {
		this.metadataService = metadataService;
	}

	public int getMetadataKey() {
		return metadataKey;
	}

	public void setMetadataKey(int metadataKey) {
		this.metadataKey = metadataKey;
	}

	public String getProjectKey() {
		return projectKey;
	}

	public void setProjectKey(String projectKey) {
		this.projectKey = projectKey;
	}

	@Override
	protected String doExecute() throws Exception {
		metadataService
				.delete(getProjectManager().getProjectObjByKey(projectKey),
						metadataKey);
		ServletActionContext.getResponse().sendRedirect(
				ServletActionContext.getRequest().getContextPath() + "/browse/"
						+ projectKey);
		return NONE;
	}
}
