package com.osoboo.jira.metadata.ui.internal;

import java.util.Map;

import com.atlassian.jira.plugin.projectpanel.impl.GenericProjectTabPanel;
import com.atlassian.jira.project.browse.BrowseContext;
import com.atlassian.jira.security.JiraAuthenticationContext;
import com.atlassian.jira.security.PermissionManager;
import com.atlassian.jira.util.JiraVelocityUtils;
import com.atlassian.jira.web.bean.I18nBean;
import com.atlassian.jira.webtests.Permissions;
import com.osoboo.jira.metadata.MetadataService;

public class ProjectMetadataPanel extends GenericProjectTabPanel {

	private MetadataService metadataService;
	private final PermissionManager permissionManager;

	public ProjectMetadataPanel(PermissionManager permissionManager,
			JiraAuthenticationContext jiraAuthenticationContext,
			MetadataService metadataService) {
		super(jiraAuthenticationContext);
		this.permissionManager = permissionManager;
		this.metadataService = metadataService;
	}

	@Override
	public String getHtml(BrowseContext ctx) {
		final Map<String, Object> params = JiraVelocityUtils
				.getDefaultVelocityParams(authenticationContext);
		params.put("i18n", new I18nBean(ctx.getUser()));
		params.put("project", ctx.getProject());
		params.put(
				"hasAdminPermission",
				permissionManager.hasPermission(Permissions.PROJECT_ADMIN,
						ctx.getProject(),
						authenticationContext.getLoggedInUser()));
		params.put("metadataService", metadataService);
		return descriptor.getHtml("view", params);
	}

}
