package com.osoboo.jira.metadata.ui.internal;

import webwork.action.ServletActionContext;

import com.atlassian.jira.web.action.JiraWebActionSupport;
import com.osoboo.jira.metadata.MetadataService;

public class ProjectMetadataSave extends JiraWebActionSupport {

	/** */
	private static final long serialVersionUID = 7861762358377860485L;

	private String metadataKey;

	private String metadataValue;

	private String projectKey;

	private final MetadataService metadataService;

	public ProjectMetadataSave(MetadataService metadataService) {
		this.metadataService = metadataService;
	}

	public String getMetadataKey() {
		return metadataKey;
	}

	public void setMetadataKey(String metadataKey) {
		this.metadataKey = metadataKey;
	}

	public String getMetadataValue() {
		return metadataValue;
	}

	public void setMetadataValue(String metadataValue) {
		this.metadataValue = metadataValue;
	}

	public String getProjectKey() {
		return projectKey;
	}

	public void setProjectKey(String projectKey) {
		this.projectKey = projectKey;
	}

	@Override
	protected String doExecute() throws Exception {
		metadataService.save(
				getProjectManager().getProjectObjByKey(projectKey),
				metadataKey, metadataValue);
		ServletActionContext.getResponse().sendRedirect(
				ServletActionContext.getRequest().getContextPath() + "/browse/"
						+ projectKey);
		return NONE;
	}
}
